#!/usr/local/bin/perl
use Socket;
push(@INC,".");
require 'jcode.pl';
require 'base64.pl';

sub print_popbyweb_header
{
    local(*FORM) = @_;

    print "<TABLE border=2><TR>\n";

    print "<TD><a href='popbyweb.html'>-popbyweb-</a>\n";
    print "<TD><FORM ACTION='maillist.pl' METHOD=POST>\n";
    print "<INPUT TYPE=submit value='Mail List'>\n";
    &print_hiddenforms(*FORM);
    print "</FORM></TD>\n";

    print "<TD><FORM ACTION='writemail.pl' METHOD=POST>\n";
    print "<INPUT TYPE=submit value='Write Mail'>\n";
    &print_hiddenforms(*FORM);
    print "</FORM></TD>\n";
    print "</TR></TABLE>\n";
    print "<br>\n";
}
sub print_popbyweb_footer
{
    print "<i><a href='http://infonet.aist-nara.ac.jp/~tsuneo-y/soft/popbyweb/'>popbyweb</a> is presented by <a href='mailto:tsuneo-y\@is.aist-nara.ac.jp'>Yoshioka Tsuneo</a></i>\n";
}
sub print_hiddenforms
{
    local(*FORM) = @_;
    print &get_hiddenforms(*FORM);
}
sub get_hiddenforms
{
    local(*FORM) = @_;
    local($key,$value);
    local($str);
    while(($key,$value) = each %FORM){
	$str .= "<INPUT TYPE=HIDDEN NAME='$key' VALUE='$value'>\n";
    }
    return $str;
}
sub get_formvars
{
    local(%FORM,%FORM2,$formstr);
    local($key,$cont);
    $formstr = $ENV{'QUERY_STRING'}; # GET
    if($formstr eq ""){sysread(STDIN,$formstr,$ENV{'CONTENT_LENGTH'});} # POST
    %FORM = (split(/[=&]/,$formstr),"");
    while(($key,$cont)=each %FORM){
	$key = &decode_formvar($key);
	$cont = &decode_formvar($cont);
	$FORM2{$key} = $cont;
    }
    return %FORM2;
}
sub die2{print @_,"\n";exit(1);}
sub encode_formvar
{
    local($var) = @_;
    s/[^\w]/unpack("H2",$1)/eg;
    return $var;
}
sub decode_formvar
{
    local($var) = @_;
    $var =~ s/\+/ /g;
    $var =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
    return $var;
}
sub decode_mailheader
{
    local($pre_process) = @_;
    local($post_process) = "";
	
    while($pre_process =~ s/=\?([^?]+)\?(.)\?([^?]*)\?=//){
	local($charset,$encoding,$strtxt) = ($1,$2,$3);
	$post_process .= $`;$pre_process = $';
	$strtxt =~ s/_/ /g;
	$strtxt = &base64'b64decode($strtxt); #'
	$post_process .= $strtxt;
    }
    $post_process .= $pre_process;
    return $post_process;
}
sub connect_popserver
{
    local(*SH,$user,$pass,$popserver) = @_;
    local($port,$addr,$sin);
    socket(SH,PF_INET,SOCK_STREAM,0)
	|| die2 "<h1>ERROR:can't open socket($!)</h1>\n";
    $port = getservbyname('pop3','tcp')
	|| die2 "<h1>ERROR:can't getservbyname('pop3')</h1>\n";
    $addr = inet_aton($FORM{'popserver'})
	|| die2 "<h1>ERROR:can't inet_aton($FORM{'popserver'})</h1>\n";
#    print "port=$port,addr=",inet_ntoa($addr),"\n";
    $sin = sockaddr_in($port,$addr);
    connect(SH,$sin)
	|| die2 "<h1>ERROR: can't connect(port=$port,popserver=$FORM{'popserver'})($!)</h1>\n";
    local($oldfh) = select(SH);$|=1;select($oldfh);

    local($line);
    local($mailnum);
    $line = <SH>;$line =~ tr/\r\n//d;# print "$line<hr>\n";
    if($line !~ /^\+OK/){die2 "ERROR:$line";}
    print SH "USER $FORM{'user'}\r\n";
    $line = <SH>;$line =~ tr/\r\n//d;#print "$line<hr>\n";
    if($line !~ /^\+OK/){die2 "ERROR:$line";}
    print SH "PASS $FORM{'pass'}\r\n";
    $line = <SH>;$line =~ tr/\r\n//d;#print "$line<hr>\n";
    if($line !~ /^\+OK/){die2 "ERROR:$line";}
    if($line =~ /(\d+)\s+message/){
	$mailnum = $1;
    }else{
	die2 "ERROR: can't found message:$line\n";
    }
    return $mailnum;
}
sub disconnect_popserver
{
    local(*SH)=@_;
    local($line);
    print SH "RSET\r\n";
    print SH "QUIT\r\n";
    $line = <SH>;$line =~ tr/\r\n//d;# print "$line<hr>\n";
    if($line !~ /^\+OK/){die2 "ERROR";}
    
    close(SH);
}
sub connect_smtpserver
{
    local(*SH,$from,$to,$body,*HEADER,$smtpserver) = @_;
    local($port,$addr,$sin);

    &jcode'convert(*from,'euc'); #'
    &jcode'convert(*to,'euc'); #'
    if($from =~ /<(.+)>/){$from = $&;}
    socket(SH,PF_INET,SOCK_STREAM,0)
	|| die2 "<h1>ERROR:can't open socket($!)</h1>\n";
    $port = getservbyname('smtp','tcp')
	|| die2 "<h1>ERROR:can't getservbyname('pop3')<h1>\n";
    $addr = inet_aton($FORM{'smtpserver'})
	|| die2 "<h1>ERROR:can't inet_aton($FORM{'popserver'})</h1>\n";
    print "port=$port,addr=",inet_ntoa($addr),"<br>\n";
    $sin = sockaddr_in($port,$addr);
    connect(SH,$sin)
	|| die2 "<h1>ERROR: can't connect(port=$port,popserver=$FORM{'popserver'})($!)</h1>\n";
    local($oldfh) = select(SH);$|=1;select($oldfh);
    
    $hostname = `hostname`;$hostname =~ tr/\r\n//d;
    if($hostname eq ""){
	die2 "ERROR: can't get hostname\n";
    }
    local($line);
    local($mailnum);
    $line = <SH>;$line =~ tr/\r\n//d;print "$line<br>\n";
    if($line !~ /^220/){die2 "ERROR";}
    print SH "HELO $hostname\r\n";
    $line = <SH>;$line =~ tr/\r\n//d;print "$line<br>\n";
    if($line !~ /^250/){die2 "ERROR";}
    if($from eq ''){die2 "ERROR: No From\n";}
    print SH "MAIL FROM: $from\r\n";
    $line = <SH>;$line =~ tr/\r\n//d;print "$line<br>\n";
    if($line !~ /^250/){die2 "ERROR";}
    if($to eq ''){die2 "ERROR: No To\n";}
    foreach $to2(split(/,/,$to)){
	if($to2 =~ /<(.+)>/){$to2 = $1;}
	print SH "RCPT TO: $to2\r\n";
	$line = <SH>;$line =~ tr/\r\n//d;print "$line<br>\n";
	if($line !~ /^250/){die2 "ERROR";}
    }
    print SH "DATA\r\n";
    $line = <SH>;$line =~ tr/\r\n//d;print "$line<br>\n";
    if($line !~ /^354/){die2 "ERROR";}

    print "<hr><pre>\n";

    while(($key,$cont) = each(%HEADER)){
	local($cont2)=$cont;
	if($cont2 !~ /^[\x20-\x7e]+$/){
	    &jcode'convert(*cont2,'jis');
	    $cont2 = &base64'b64encode($cont2);
	    $cont2 = "=?iso-2022-jp?B?${cont2}?="; 
	    $cont2 =~ tr/\r\n//d;
	}
	print SH "$key: $cont2\r\n";
	print "$key: $cont2\n";
    }
   # print "----\n";
    print SH "\r\n";
    &jcode'convert(*body,'jis'); #'
    $body =~ s/\r//g;
    $body =~ s/\n\./\n\. /g;
    $body =~ s/\n/\r\n/g;
    print SH $body;
    print SH "\r\n.\r\n";

    print "</pre><hr>\n";

    $line = <SH>;$line =~ tr/\r\n//d;print "$line<br>\n";
    if($line !~ /^250/){die2 "ERROR";}
    print "<h1>Message Send Successed!</h1>\n";
}
sub disconnect_smtpserver
{
    local(*SH)=@_;
    local($line);
    print SH "QUIT\r\n";
    $line = <SH>;$line =~ tr/\r\n//d;print "$line<hr>\n";
    if($line !~ /^\+OK/){die2 "ERROR";}
    
    close(SH);
}

1;
